//
// Copyright 1993,1994,1995 Steve Passe and Paul Crook
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1995 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//              Paul Crook
//

// "$Id: connection.hh,v 1.4 1996/03/03 03:56:36 smp Exp smp $"


//
// connection.hh
//


#ifndef _CONNECTION_H
#define _CONNECTION_H

#include "util/misc/udgsocket.hh"

#define MAX_CONNECTION	8


class Connection
{

 public:

    Connection( const char* me, const char* you );
    ~Connection();

    // 
    int send( const char* msg );

    // 
    int recv( char* msg );

    //
    int getFD( void ) { return _connections[ _handle ]._socket->getFD(); }


 private:

/// FIXME: need to use dArray class here
    static struct Udgs {
	Udgs() { _refCount = 0;
		 _myName = NULL;
		 _yourName = NULL;
		 _socket = NULL; }

	short		_refCount;
	char*		_myName;
	char*		_yourName;
	UnixDGSocket*	_socket;

    } _connections[ MAX_CONNECTION ];


    // 
    static int getSocket( const char* me, const char* you );

    int _handle;
};

#if 0
    // read message from specific UDG socket
    int			readMessage( UnixDGSocket* udgs,
				     UNIXSOCKADDR* addr,
				     u_char* msg );

    // write message to specific UDG socket
    int			writeMessage( UnixDGSocket* udgs,
				      UNIXSOCKADDR* addr,
				      const u_char* msg,
				      int count );
#endif // 0

#endif  // _CONNECTION_H
