//
// Copyright 1993,1994,1995 Steve Passe and Paul Crook
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1995 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//              Paul Crook
//

static char rcsid[] = "$Id: system.cc,v 1.2 1996/03/02 08:12:45 smp Exp smp $";


//
// system.c
//

#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>

#include "util/misc/misc.hh"
#include "util/misc/tokens.hh"

#include "system.hh"


//
// constructor, store args for action
//
System::System( const char* args, const char* me, const char* you )
{
    // keep a copy of the args
    _args = new char[ strlen( args ) + 1 ];
    strcpy( _args, args );

    // (optionally) create a conection
    if ( (me != NULL) && (you != NULL) )
    {
	_port = new Connection( me, you );
    }

    else
    {
	delete _args;
	_args = NULL;
	_port = NULL;
    }

    return;
}


//
// constructor, store args for action
//
System::System( const char* args )
{
    // keep a copy of the args
    _args = new char[ strlen( args ) + 1 ];
    strcpy( _args, args );

    //
    _port = NULL;

    return;
}


//
// either send args to remote system
//  or
// do local system() call
//
int
System::action( void )
{

    if ( _port && _args )
    {
	_port->send( _args );
    }

    else if ( _args )
    {
	system( _args );
    }

    return OK;
}
