//
// Copyright 1996 Steve Passe
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1996 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//

// $Id: mlcontrol.hh,v 1.3 1996/03/31 03:09:06 smp Exp smp $


//
// mlcontrol.hh, header for mlcontrol.cc
//


#ifndef _MLCONTROL_H
#define _MLCONTROL_H

#include <unistd.h>

#include "../daemon/rcclient.hh"


#define MAX_INPUT		1024
#define COMMENT_CHAR		'#'

#define STATUS_MSG_START	'<'


class MLControl : public RcClient
{

 public:

    // constructor
    MLControl( const char* name ) : RcClient( name ) {}

    // destructor
    virtual		~MLControl( void ) {}

    // initialize Control
    virtual int		initialize( const char* path, const char* logFile )
    			    { return RcClient::initialize( path, logFile ); }

    // the main loop
    int			mlMain( void );


 protected:


 private:

};


#endif // _MLCONTROL_H
