//
// Copyright 1996 Steve Passe
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1996 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//

// $Id: mlds1920.hh,v 1.4 1996/03/15 22:44:17 smp Exp smp $

//
// MicroLAN is a trademark Dallas Semiconductor
//

//
// mlds1920.hh
//


#ifndef _MLDS1920_H
#define _MLDS1920_H

#include "mldevice.hh"


//
// 
//
class MLDS1920TouchThermometer : public MLDevice
{

 public:

    MLDS1920TouchThermometer( MLBusMaster& m )
	: MLDevice( _MLDS1920_FAMILY_CODE, m ) {}
       
    MLDS1920TouchThermometer( MLBusMaster& m, const BYTE* id )
	: MLDevice( id, m ) {}


 private:

    enum MLDS1920_COMMAND
    {
	_SCRATCH_READ		= 0xbe,
	_SCRATCH_WRITE		= 0x4e,
	_SCRATCH_COPY		= 0x48,
	_RECALL_COMMAND		= 0xb8,
	_CONVERT_COMMAND	= 0x44
    };

};


# if 0

//
// 
//
int
MLDS1920TouchThermometer::getTemperature( int& temperature )
{
    UTDarray< UINT8 > results ;
    results.SetSize( CONVERT_RESULT_SIZE );
    int crcResult ;
    int waitTime = 16384 ;

    GetBusMaster().Send( CONVERT_COMMAND,
			GetSCRATCH_READ(), 
			_DeviceID.GetSerialNumber(),
			CONVERT_RESULT_SIZE,
			results,
			CRC_TYPE_8BIT,
			crcResult,
			waitTime );

    // do temperature conversion here ...

    }

//
// 
//
int
MLDS1920TouchThermometer::send( 
	     int romCommand,                     // command to send to devices
	     int readCommand,                    // command to read the results
	     int address,                        // add of device or 0 for none
	     int sizeOfResult,                   // expected size of result
	     UTDArray& result,                   // container for result
	     CRC_TYPE crcType = CRC_TYPE_NONE,   // type of CRC check
	     int& crcResult = m_crcDummy,        // result of CRC check
	     int waitTime = REGULAR_WAIT_TIME ); // how long to wait for result

# endif  // 0

#endif // _MLDS1920_H
