# rcsid $Id: rc.mk,v 1.2 1996/02/27 20:01:42 smp Exp smp $

#
# site customization
#

# base for source tree
BUILD_DIR = /usr/local/src/control

# base for installed binaries & control files
INSTALL_DIR = /usr/local/control

#
# DEFINES:
#
#  hardware definations:
#
#   DEV_TW: FreeBSD /dev/tw X10 controller
#   SERPLIX: micromint based serial X10 controller
#   LYNX10: Merrick Product's LynX-10 serial controller
#
#   HAVE_IR: infrared controller available
#    SIR: serial infrared controller
#    LIR: learning infrared controller
#
#   HAVE_VOICE: text-to-speech controller available
#    SERIAL_TTS: serial box
#    RSYNTH_TTS: rsynth

SIR = 1
LIR = 2

SERIAL_TTS=1
RSYNTH_TTS=2

DEFINES = \
	-DSERPLIX \
	-DHAVE_IR=$(SIR) \
	-DHAVE_VOICE=$(SERIAL_TTS) \
	-DSIR=$(SIR) -DLIR=$(LIR) \
	-DSERIAL_TTS=$(SERIAL_TTS) -DRSYNTH_TTS=$(RSYNTH_TTS) \
	-DBASE="\"$(INSTALL_DIR)\""

##	-DDEV_TW \
## or
##	-DLYNX10 \
## or
##	-DSERPLIX \

##	-DSIR=$(SIR) -DLIR=$(LIR) \
##	-DSERIAL_TTS=$(SERIAL_TTS) -DRSYNTH_TTS=$(RSYNTH_TTS) \
##	-DBASE="\"$(INSTALL_DIR)\""

#
# end site customization, DON'T modify  below this line.
#

# easy path to include files
INCLUDES = -I$(BUILD_DIR)

# binaries kept here
BIN_DIR = $(INSTALL_DIR)/bin

# base for data files
DATA_DIR = $(INSTALL_DIR)/etc

# base for documentation
DOC_DIR = $(INSTALL_DIR)/doc

# base for data files
LOG_DIR = $(INSTALL_DIR)/log

UTIL_DIR = $(BUILD_DIR)/util
SRVR_DIR = $(BUILD_DIR)/rc/daemon
LIB_DIR =  $(BUILD_DIR)/rc/x10client

SGMLFORMAT = sgmlfmt

