//
// Copyright 1996 Steve Passe
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1996 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//

// $Id$


//
// rccontrol.hh, header for rccontrol.cc
//


#ifndef _RCCONTROL_H
#define _RCCONTROL_H

#include <unistd.h>

#include "../daemon/rcclient.hh"

#define MAX_INPUT		1024
#define COMMENT_CHAR		'#'

#define STATUS_MSG_START	'<'

/// FIXME: specific to HCSII
struct SENSORDATA {
    const char*		name;
} sensorData[] =
{
  { "front door"		},
  { "west office door"		},
  { "back door"			},
  { "east office door"		},
  { "bathroom door"		},
  { "library door"		},
  { "patio door"		},
  { "patio window"		},
  { "stair closet"		},
  { "bedroom door"		},
  { "mechanical room door"	},
  { "greenhouse door"		},
  { "spare input"		},
  { "panic button"		},
  { "test button"		},
  { "arm button"		}
};


class RcControl : public RcClient
{

 public:

    // constructor
    RcControl( const char* name ) : RcClient( name ) {}

    // destructor
    virtual		~RcControl( void ) {}

    // initialize Control
    virtual int		initialize( const char* path, const char* logFile )
			    { return RcClient::initialize( path, logFile ); }

    // the main loop
    int			rcMain( void );


 protected:


 private:

    int			doClient( Connection* hcs2Cmnd,
				  const char* hcs2EventAddr,
				  Connection* x10Cmnd,
				  const char* x10EventAddr );

    int			doHcs2Cmnd( Connection* hcs2Cmnd );
    int			doHcs2Event( Connection* hcs2Event );

    int			doX10Cmnd( Connection* x10Cmnd );
    int			doX10Event( Connection* x10Event );
};


#endif // _RCCONTROL_H
