//
// Copyright 1993,1994,1995 Steve Passe and Paul Crook
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1995 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//              Paul Crook
//

static char rcsid[] = "$Id: xx10mini.c,v 1.3 1995/09/26 03:42:10 smp Exp smp $";

#define MENUBAR_NOT

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

// Xlib headers
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>

// Standard Xt headers
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

// Athena Widget Set headers
#if 0
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
#endif

// FWF Widget Set headers
#include <Xfwf/Board.h>
#include <Xfwf/Label.h>
#include <Xfwf/Button.h>
#include <Xfwf/MenuBar.h>
#include <Xfwf/PullDown.h>
#include <Xfwf/OptButton.h>
#include <Xfwf/TextMenu.h>
#include <Xfwf/RowCol.h>

// rc client & server hook routines
#include "rc/daemon/rcserver.hh"
#include "rc/x10client/x10client.hh"
#include "rc/x10d/x10.hh"
#include "rc/x10d/x10daemon.hh"

// under construction
#define USE_ACCELERATORS_NOT

// magic, won't work unless your mapping file (X10Map) cooperates!
#define VERBAL_TOGGLE	AREA_P, KEY_14

// misc. values
#define NUM_ROCKERS	4
#define NUM_AREAS	16
#define DEFAULT_AREA	"A"
#define FIRST_AREA	'A'
#define DEFAULT_BASE	0
#define FIRST_BASE	'0'

// instance & class names for X resource access
const static char* appName = "xx10mini";
const static char* appClass = "Xx10mini";

//
// set the fallback resources
//
static String fallbackResources[] = {

"Xx10mini*x10verbal:			0",
"Xx10mini*x10area:			" DEFAULT_AREA,

"Xx10mini.Width:			260",
"Xx10mini.Height:			145",
"Xx10mini.BorderWidth:			0",


"Xx10mini*menu.frameWidth:	        0",
"Xx10mini*menu.innerOffset:		0",
"Xx10mini.XfwfBoard.menu.outerOffset:	0",

"Xx10mini.XfwfBoard.keys.innerOffset:	0",
"Xx10mini.XfwfBoard.keys.outerOffset:	0",

"Xx10mini*XfwfBoard.XfwfLabel.foreground:	white",
"Xx10mini*XfwfBoard.XfwfLabel.background:	grey",

"Xx10mini*keys*font: *-*-Helvetica-medium-r-*-*-*-100-*-*-p-*-*-*",

//                                      X        Y       WIDTH    HEIGHT
"Xx10mini*menu.location:		0.0      0.0     1.0      0.20",
"Xx10mini*menu.label.location:		0.0      0.0     1.0      1.0",
"Xx10mini*keys.location:		0.0      0.20    1.0      0.80",


//                                      X        Y       WIDTH    HEIGHT
"Xx10mini*rocker1a.location:		0.0+2    0.0+2   0.166-2  0.50-2",
"Xx10mini*rocker1b.location:		0.0+2    0.5+2   0.166-2  0.50-2",
"Xx10mini*rocker2a.location:		0.166+2  0.0+2   0.166-2  0.50-2",
"Xx10mini*rocker2b.location:		0.166+2  0.5+2   0.166-2  0.50-2",
"Xx10mini*rocker3a.location:		0.332+2  0.0+2   0.166-2  0.50-2",
"Xx10mini*rocker3b.location:		0.332+2  0.5+2   0.166-2  0.50-2",
"Xx10mini*rocker4a.location:		0.498+2  0.0+2   0.166-2  0.50-2",
"Xx10mini*rocker4b.location:		0.498+2  0.5+2   0.166-2  0.50-2",

"Xx10mini*brite.location:		0.665+2  0.0+2   0.167-2  0.50-2",
"Xx10mini*dim.location:			0.665+2  0.5+2   0.167-2  0.50-2",
"Xx10mini*alo.location:			0.832+2  0.0+2   0.167-2  0.50-2",
"Xx10mini*auo.location:			0.832+2  0.5+2   0.167-2  0.50-2",

"Xx10mini*rocker1a.foreground:		black",
"Xx10mini*rocker1a.background:		lightgrey",
"Xx10mini*rocker1b.foreground:		black",
"Xx10mini*rocker1b.background:		lightgrey",

"Xx10mini*rocker2a.foreground:		black",
"Xx10mini*rocker2a.background:		lightgrey",
"Xx10mini*rocker2b.foreground:		black",
"Xx10mini*rocker2b.background:		lightgrey",

"Xx10mini*rocker3a.foreground:		black",
"Xx10mini*rocker3a.background:		lightgrey",
"Xx10mini*rocker3b.foreground:		black",
"Xx10mini*rocker3b.background:		lightgrey",

"Xx10mini*rocker4a.foreground:		black",
"Xx10mini*rocker4a.background:		lightgrey",
"Xx10mini*rocker4b.foreground:		black",
"Xx10mini*rocker4b.background:		lightgrey",

"Xx10mini*brite.foreground:		black",
"Xx10mini*brite.background:		tan",

"Xx10mini*dim.foreground:		black",
"Xx10mini*dim.background:		tan",

"Xx10mini*alo.foreground:		black",
"Xx10mini*alo.background:		tan",

"Xx10mini*auo.foreground:		black",
"Xx10mini*auo.background:		tan",

"Xx10mini*background:	 		grey30",

#if defined( MENUBAR )

"Xx10mini*menuBar.location:	 	0 0 1.0 1.0",
"Xx10mini*menuBar.frameWidth:	 	2",
"Xx10mini*menuBar.frameType:	 	raised",
"Xx10mini*menuBar.highlightThickness:	0",
"Xx10mini*menuBar.traversalOn:	 	true",
"Xx10mini*menuBar*background:	 	grey30",
"Xx10mini*menuBar*foreground:	 	white",
"Xx10mini*menuBar*font:	 		*-helvetica-bold-r-*-140-*",

#else

"Xx10mini*menu*background:	 	grey30",
"Xx10mini*menu*foreground:	 	white",
"Xx10mini*menu*font:	 		*-helvetica-bold-r-*-140-*",

#endif

#if 0
"Xx10mini*XfwfTextMenu*background:	 red",
"Xx10mini*XfwfTextMenu*foreground:	 green",
#endif

"Xx10mini*XfwfTextMenu*font:	 	*-helvetica-bold-r-*-140-*",

"Xx10mini*oMenu.label:	 		X10 Mini",

#if !defined( MENUBAR )
"Xx10mini*aMenu.location: 		0.5 0 1.0 1.0",
#endif

#if defined( USE_ACCELERATORS )
"Xx10mini*oMenu.hotkey:	 		<Ctrl>1",
#endif  // USE_ACCELERATORS

"Xx10mini*oMenu.menu:\
	_Verbal\\n\
	-----------\\n\
	_Exit",
    
"Xx10mini*aMenu.label:	 		<NONE>",
"Xx10mini*aMenu.menu:	  		Fix Your Resources",

NULL

};


//
// application resource setup
//
#define	XtNx10area	"x10area"
#define	XtCX10Area	"X10Area"
#define	XtNx10base	"x10base"
#define	XtCX10Base	"X10Base"
#define	XtNx10areaList	"x10areaList"
#define	XtCX10AreaList	"X10AreaList"
#define	XtNx10verbal	"x10verbal"
#define	XtCX10Verbal	"X10Verbal"

typedef struct {
    char*	x10area;
    char*	x10areaList;
    int		x10base;
    int		x10verbal;
} appResources_t, *appResourcesPtr;

static appResources_t	appResources;

static XtResource	resources[] = {
#define offset(field)		XtOffset(appResourcesPtr, field)

	{ XtNx10area, XtCX10Area, XtRString, sizeof(char*),
		offset(x10area), XtRImmediate, (XtPointer)DEFAULT_AREA },

	{ XtNx10areaList, XtCX10AreaList, XtRString, sizeof(char*),
		offset(x10areaList), XtRImmediate, (XtPointer)"" },

	{ XtNx10base, XtCX10Base, XtRInt, sizeof(int), 
		offset(x10base), XtRImmediate, (XtPointer)DEFAULT_BASE },

	{ XtNx10verbal, XtCX10Verbal, XtRInt, sizeof(int), 
		offset(x10verbal), XtRImmediate, (XtPointer)0 },

#undef offset
};

static XrmOptionDescRec options[] = {
	{ "-a",	".x10area",	XrmoptionSepArg, (caddr_t) DEFAULT_AREA },
	{ "-l",	".x10areaList",	XrmoptionSepArg, (caddr_t) "" },
	{ "-b",	".x10base",	XrmoptionSepArg, (caddr_t) DEFAULT_BASE },
	{ "-v",	".x10verbal",	XrmoptionSepArg, (caddr_t) 0 },
};


//
// global variables
//
static Widget	rockers[ NUM_ROCKERS ][ 2 ];

const int	x10Command = X10DUAL;
static int	x10Area = AREA_A;
static int	x10UnitBase = 0;

static int	x10verbal = 0;

//
// data for area pulldown menu
//
typedef struct {
    char*	label;		// button label
    int		area;		// software house code
    int		base;		// zero-based base
} areaTag;

// label to x10 area associations for area menu
areaTag areaList[ 17 ] = {
    { NULL,	-1,    -1 }
};


// callback functions

static void optionsCB( Widget, XtPointer, XtPointer );
static void areaCB( Widget, XtPointer, XtPointer );

static void rockerOnCB( Widget, XtPointer, XtPointer );
static void rockerOffCB( Widget, XtPointer, XtPointer );
static void pushBCB( Widget, XtPointer, XtPointer );

// other local functions
static void initializeX10( void );
static int buildAreaList( char* );
static void buildAreaMenu( Widget, areaTag*, int );
static void createButton( Widget, Widget*, char*, char*,
			  XtCallbackProc, XtPointer );


int
main( int argc, char **argv )
{
    XtAppContext	appContext;
    Widget		topLevel;
    Widget		mainBox;
    Widget		mainMenu;
    Widget		menuBar;
    Widget		optionsMenu;
    Widget		areaMenu;
    Widget		buttonForm;
    Widget		briteButton;
    Widget		dimButton;
    Widget		allOnButton;
    Widget		allOffButton;
    Display*		display;
    Arg			args[ 10 ];
    char		s[ 133 ];
    int			i, x;
    int			defaultAreaIndex = -1;

    // setup communications with the rc Daemon
    if ( attachDaemon() )
    {
	cerr << "attachDaemon() failed!\n";
	exit( 1 );
    }
    initializeX10();

    // create top level shell
    topLevel = XtVaAppInitialize( &appContext, appClass,
				  options, XtNumber(options),
				  &argc, argv, fallbackResources, NULL );

    // process remaining commandline args
    XtGetApplicationResources( topLevel,
			       &appResources, resources, XtNumber(resources),
			       0, 0 );

    // process appResources
    x10Area = appResources.x10area[0] - FIRST_AREA;
    x10UnitBase = appResources.x10base;
    x10verbal = appResources.x10verbal;
    defaultAreaIndex = buildAreaList( appResources.x10areaList );

    // general X stuff
    display = XtDisplay(topLevel);
 
    // the top level container
    mainBox = XtVaCreateManagedWidget( "mainBox", xfwfBoardWidgetClass,
				       topLevel, NULL );

    //
    // menu
    //
    mainMenu = XtVaCreateManagedWidget( "menu", xfwfBoardWidgetClass,
					 mainBox, NULL );

#if defined( MENUBAR )
    menuBar = XtVaCreateManagedWidget( "menuBar", xfwfMenuBarWidgetClass,
				       mainMenu, NULL );
#endif

    optionsMenu = XtVaCreateManagedWidget( "oMenu", xfwfPullDownWidgetClass,
#if defined( MENUBAR )
					   menuBar, NULL );
#else
					   mainMenu, NULL );
#endif

    XtAddCallback( optionsMenu, XtNactivate, optionsCB, NULL );

    areaMenu = XtVaCreateManagedWidget( "aMenu", xfwfOptionButtonWidgetClass,
#if defined( MENUBAR )
					   menuBar, NULL );
#else
					   mainMenu, NULL );
#endif

    XtAddCallback( areaMenu, XtNactivate, areaCB, NULL);

    // build custom area menu
    buildAreaMenu( areaMenu, areaList, defaultAreaIndex );

#if defined( USE_ACCELERATORS )
    XtInstallAllAccelerators( topLevel, topLevel );
///    XtInstallAllAccelerators( menuBar, topLevel );
    XtInstallAllAccelerators( optionsMenu, topLevel );
    XtInstallAllAccelerators( areaMenu, topLevel );
#endif  // USE_ACCELERATORS

    //
    // key form
    //
    buttonForm = XtVaCreateManagedWidget( "keys", xfwfBoardWidgetClass,
					  mainBox, NULL);

    // create pairs of ON/OFF buttons
    for ( x = 0; x < NUM_ROCKERS; ++x )
    {
	sprintf( s, "rocker%da", x+1 );
	createButton( buttonForm, &rockers[ x ][ 0 ], s, "On",
		      rockerOnCB, (XtPointer*)x );

	sprintf( s, "rocker%db", x+1 );
	createButton( buttonForm, &rockers[ x ][ 1 ], s, "Off",
		      rockerOffCB, (XtPointer*)x );
    }

    // create colored buttons
    createButton( buttonForm, &briteButton, "brite", "Brite",
		  pushBCB, (XtPointer*)1 );
    createButton( buttonForm, &dimButton, "dim", "Dim",
		  pushBCB, (XtPointer*)2 );
    createButton( buttonForm, &allOnButton, "alo", "All\nLights\nOn",
		  pushBCB, (XtPointer*)3 );
    createButton( buttonForm, &allOffButton, "auo", "All\nUnits\nOff",
		  pushBCB, (XtPointer*)4 );

    // make it all happen
    XtRealizeWidget( topLevel );

    // ...if only this was done with threads...
    XtAppMainLoop( appContext );
}


//
// setup an assummed x10 state
//
static void
initializeX10( void )
{
    if ( areaList[ 0 ].area != -1 )
    {
	x10Area = areaList[ 0 ].area;
    }

    if ( areaList[ 0 ].base != -1 )
    {
	x10UnitBase = areaList[ 0 ].base;
    }
}


//
// 
//
#define SKIPWS(c)	while( isspace((*p)) ) ++p
static int
buildAreaList( char* areaStr )
{
    int index = -1;

    if ( areaStr == NULL ) return index;

    // get string into a local buffer
    char* s = new char[ strlen(areaStr)+1 ];
    strcpy( s, areaStr );

    // get the first label
    char* p = strtok( s, "," );

    // process each of NUM_AREAS possible areas
    for ( int x = 0; x < NUM_AREAS; ++x )
    {
	// assign the label
	areaList[ x ].label = p;

	// get an area value
	if ( (p = strtok( NULL, "," )) == NULL ) break;
	SKIPWS( p );
	areaList[ x ].area = p[0] - FIRST_AREA;

	// look for default label
	if ( areaList[ x ].area == x10Area )
	{
	   index = x;
	}

	// get a base value
	if ( (p = strtok( NULL, "," )) == NULL ) break;
	SKIPWS( p );
	areaList[ x ].base = p[0] - FIRST_BASE;

	// get the next label
	if ( (p = strtok( NULL, "," )) == NULL ) break;
    }

    return index;
}


//
// 
//
static void
buildAreaMenu( Widget areaMenu, areaTag* aList, int defaultIndex )
{
    int x, c;
    Arg args[ 10 ];

    if ( aList[ 0 ].label == NULL ) return;

    // compute total length
    for ( c = 0, x = 0;  ; ++x )
    {
	c += (strlen( aList[ x ].label ) + 2);
	if ( aList[ x+1 ].label == NULL ) break;
    }
    ++c;

    // build menu
    char* s = new char[ c ];
    s[ 0 ] = '\0';
    for ( x = 0;  ; ++x )
    {
	strcat( s, aList[ x ].label );
	if ( aList[ x+1 ].label == NULL ) break;
	strcat( s, "\n" );
    }

    if ( defaultIndex == -1 ) defaultIndex = 0;
    int i = 0;
    XtSetArg( args[i], XtNlabel, aList[ defaultIndex ].label );  i++;
    XtSetArg( args[i], XtNmenu, s );  i++;
    XtSetValues( areaMenu, args, i);

///    delete [] s;
}


// create push buttons
static void
createButton( Widget p, Widget *w, char* name, char* label,
	      XtCallbackProc callBack, XtPointer callData )
{
    *w = XtVaCreateManagedWidget( name, xfwfButtonWidgetClass, p,
				  XtNlabel, label, NULL );
    XtAddCallback( *w, XtNactivate, callBack, callData );
}


//
// options menu callback
//
static void
optionsCB( Widget w, XtPointer clientData, XtPointer callData )
{
    XfwfTextMenuData& data = *(XfwfTextMenuData*)callData;

    switch ( data.n )
    {
    case 0:
	sendX10Command( x10Command, VERBAL_TOGGLE );
	break;
    case 1:
	exit(0);
    default:
	break;
    }
}


//
// process the area menu
//
static void
areaCB( Widget w, XtPointer clientData, XtPointer callData )
{
    XfwfTextMenuData& data = *(XfwfTextMenuData*)callData;

    x10Area = areaList[ data.n ].area;
    x10UnitBase = areaList[ data.n ].base;
}


//
// the on/off rocker buttons
//
static void
rockerOnCB( Widget w, XtPointer clientData, XtPointer callData )
{
    int unit = (int)clientData;

    sendX10Command( x10Command, x10Area, unit + x10UnitBase );

    sendX10Command( x10Command, x10Area, KEY_ON );
}


static void
rockerOffCB( Widget w, XtPointer clientData, XtPointer callData )
{
    int unit = (int)clientData;

    sendX10Command( x10Command, x10Area, unit + x10UnitBase );

    sendX10Command( x10Command, x10Area, KEY_OFF );
}


//
// process the tan pushbuttons
//
static void
pushBCB( Widget w, XtPointer clientData, XtPointer callData )
{
    int	command;

    switch ( (int)clientData )
    {
    case 1: command = KEY_BRIGHT;		break;
    case 2: command = KEY_DIM;			break;
    case 3: command = KEY_ALL_LIGHTS_ON;	break;
    case 4: command = KEY_ALL_UNITS_OFF;	break;
    default: return;
    }

    sendX10Command( x10Command, x10Area, command );
}
