//
// Copyright 1993,1994,1995 Steve Passe and Paul Crook
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1995 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//              Paul Crook
//

// $Id: x10.hh,v 1.2 1996/03/31 01:59:44 smp Exp smp $


//
// x10.h
//


//
// repeat count for standard commands
//
#define REPEAT_COUNT	2


//
// house code values used by x10 hardware
//
enum X10HouseCode {
    HOUSE_M =  0,
    HOUSE_N =  1,
    HOUSE_O =  2,
    HOUSE_P =  3,
    HOUSE_C =  4,
    HOUSE_D =  5,
    HOUSE_A =  6,
    HOUSE_B =  7,
    HOUSE_E =  8,
    HOUSE_F =  9,
    HOUSE_G = 10,
    HOUSE_H = 11,
    HOUSE_K = 12,
    HOUSE_L = 13,
    HOUSE_I = 14,
    HOUSE_J = 15
};


//
// 'room' code values used by the software
///
enum areaCode {
    AREA_A,
    AREA_B,
    AREA_C,
    AREA_D,
    AREA_E,
    AREA_F,
    AREA_G,
    AREA_H,
    AREA_I,
    AREA_J,
    AREA_K,
    AREA_L,
    AREA_M,
    AREA_N,
    AREA_O,
    AREA_P
};


//
// unit & function codes used by x10 hardware
//
enum X10Function {
    UNIT_13 =                0,
    UNIT_14 =                1,
    UNIT_15 =                2,
    UNIT_16 =                3,
    UNIT_3 =                 4,
    UNIT_4 =                 5,
    UNIT_1 =                 6,
    UNIT_2 =                 7,
    UNIT_5 =                 8,
    UNIT_6 =                 9,
    UNIT_7 =                10,
    UNIT_8 =                11,
    UNIT_11 =               12,
    UNIT_12 =               13,
    UNIT_9 =                14,
    UNIT_10 =               15,
    FUNC_ALL_UNITS_OFF =    16,
    FUNC_HAIL_REQUEST =     17,
    FUNC_DIM =              18,
    FUNC_EXTENDED_DATA =    19,
    FUNC_ON =               20,
    FUNC_PRESET_DIM_LOW =   21,
    FUNC_ALL_LIGHTS_OFF =   22,
    FUNC_STATUS_EQ_OFF =    23,
    FUNC_ALL_LIGHTS_ON =    24,
    FUNC_HAIL_ACKNOWLEDGE = 25,
    FUNC_BRIGHT =           26,
    FUNC_STATUS_EQ_ON =     27,
    FUNC_OFF =              28,
    FUNC_PRESET_DIM_HIGH =  29,
    FUNC_EXTENDED_CODE =    30,
    FUNC_STATUS_REQUEST =   31
};


//
// unit & function codes used by the software
//
enum keyCode {
    KEY_1,
    KEY_2,
    KEY_3,
    KEY_4,
    KEY_5,
    KEY_6,
    KEY_7,
    KEY_8,
    KEY_9,
    KEY_10,
    KEY_11,
    KEY_12,
    KEY_13,
    KEY_14,
    KEY_15,
    KEY_16,
    KEY_ALL_UNITS_OFF,
    KEY_ALL_LIGHTS_ON,
    KEY_ON,
    KEY_OFF,
    KEY_DIM,
    KEY_BRIGHT,
    KEY_ALL_LIGHTS_OFF,
    KEY_EXTENDED_CODE,
    KEY_HAIL_REQUEST,
    KEY_HAIL_ACKNOWLEDGE,
    KEY_PRESET_DIM_LOW,
    KEY_PRESET_DIM_HIGH,
    KEY_EXTENDED_DATA,
    KEY_STATUS_EQ_ON,
    KEY_STATUS_EQ_OFF,
    KEY_STATUS_REQUEST
};
