//
// Copyright 1993,1994,1995 Steve Passe and Paul Crook
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1995 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//              Paul Crook
//

// $Id: x10action.hh,v 1.4 1996/03/31 01:58:53 smp Exp smp $


#ifndef _X10_ACTION
#define _X10_ACTION

#include "../daemon/action.hh"


// number of entries in the key map table
#define KEYMAPSIZE		512
///#define ACTION_MAGIC		0xfa05
#define OBJECT_MAGIC		0xfa06

#define COMMAND_EMIT		1
#define COMMAND_VTOGGLE		2


// items pointed to by key map table entries
typedef struct x10Action X10ACTION;
struct x10Action {
    u_short	magic;
    u_short	flags;
    u_char	priority;
    u_char	group;

    short	index;
    X10ACTION*	next;
    X10ACTION*	last;

    /// FIX ME this should be a test object
    int		(*test)(u_char*);
    u_char*	tArgs;

    Action*	object;
};

// pointer to function taking pointer to X10ACTION as arg
typedef	int			(*PFX10A)(X10ACTION *);


//
// class to handle X-10 specific actions
//
class X10Action : public Action {

 public:

    X10Action( const char* );
    virtual ~X10Action() { delete _args; }
    int virtual action( void );

 private:

    int			_command;
    u_char*		_args;
};


#endif  // _X10_ACTION
