//
// Copyright 1993,1994,1995 Steve Passe and Paul Crook
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1995 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//              Paul Crook
//

// $Id: x10d.hh,v 1.4 1996/03/31 02:03:00 smp Exp smp $


//
// x10d.hh, header for x10d.cc, etc.
//


//
// globals accessable from external library functions
//
#if defined( X10D )
# define EXTERN
#else
# define EXTERN extern
#endif

#include "util/misc/namedstr.hh"
EXTERN NamedStr	defaults;
EXTERN int	verbose;
EXTERN int	verbal;			/// THIS REALLY BELONGS IN ???

#include "util/misc/keymap.hh"
EXTERN KeyMap	x10Map;

EXTERN int	room, key;
EXTERN int	lastKey[ 16 ], lastUnit[ 16 ], lastFunction[ 16 ];
EXTERN u_short	unitsGroup[ 16 ], functionsGroup[ 16 ];

EXTERN int	readerPid, writerPid;
EXTERN int	readerPipe, writerPipe;

//
// ascii names for 'room's & 'key's
//

// default ascii names of the rooms
#if defined( X10D )
char	*roomNames[] = {
    "A",
    "B",
    "C",
    "D",
    "E",
    "F",
    "G",
    "H",
    "I",
    "J",
    "K",
    "L",
    "M",
    "N",
    "O",
    "P"
};
#else
extern char	*roomNames[];
#endif

// default ascii names of the keys
#if defined( X10D )
char *keyNames[] = {
    "1",
    "2",
    "3",
    "4",
    "5",
    "6",
    "7",
    "8",
    "9",
    "ten",
    "eleven",
    "twelve",
    "thirteen",
    "fourteen",
    "fifteen",
    "sixteen",
    "All Units Off",
    "All Lights On",
    "On",
    "Off",
    "Dim",
    "Bright",
    "All Lights Off",
    "Extended Code",
    "Hail Request",
    "Hail Acknowledge",
    "Preset Dim Low",
    "Preset Dim High",
    "Extended Data",
    "Status On",
    "Status Off",
    "Status Request"
};
#else
extern char	*keyNames[];
#endif

int		scanArg( char *, char * );
void		markLog( char * );


#define RMKY_TO_MAP(R,K)	(((R)<<5)|(K))
#define MAP_TO_ROOM(M)		(((M)>>5)&0x0f)
#define MAP_TO_KEY(M)		((M)&0x1f)
#define IS_A_UNIT(K)		((K) <= KEY_16 ? 1 : 0)
#define IS_A_FUNC(K)		((K) > KEY_16 ? 1 : 0)
