//
// Copyright 1993,1994,1995 Steve Passe and Paul Crook
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1995 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//              Paul Crook
//

// $Id: x10daemon.hh,v 1.4 1996/03/31 02:03:51 smp Exp smp $


//
// x10daemon.hh, header for x10daemon.cc
//


// X-10 constants
#define MIN_X10_SEPARATION	20		// hundredths of a sec
#define TIMESTAMPSIZE		2
#define READX10SIZE		(2+TIMESTAMPSIZE)
#define WRITEX10SIZE		3


#define CNTL_BSIZE		4
#define RC_CMND			0
#define X10_AREA		1
#define X10_UNIT		2
#define X10_RCNT		3


enum serverCmnds {
    X10EXEC = 1,
    X10KILL,
    MAP,
    UNMAP,
    X10VIRTUAL,
    X10DUAL
};


// reader process
#if defined( SERPLIX )
void	reader( int, int );
#else
void	reader( int );
#endif  // SERPLIX


// writer process
void	writer( int );
int	writeX10( u_char, u_char* );


// daemon (parent) process
typedef		void(*PFIV)(int);
typedef		void(*PFVV)();

void		daemon( const char* );
void		daemonTerminate( void );
int		killX10d( void );


#if defined( NO_ZOMBIES_ALLOWED )
void		childDeath( void );
#endif  // NO_ZOMBIES_ALLOWED


// misc
void		clearMap( void );



const short MAX_PATTERN_KEYS = 2;

const short DEFAULT_PRIORITY = 128;

// field types
const char TYPE_PATTERN = 1;
const char TYPE_ACTION = 2;
const char TYPE_OPTION = 3;

// pattern values
const char VALUE_KEYS = 10;
const char VALUE_CONTROL = 11;
const char VALUE_STATUS = 12;

// action values
const char VALUE_MESSAGE = 20;
const char VALUE_SYSTEM = 21;

// option values
const char VALUE_PRIORITY = 30;

// pattern tests
const char TEST_KEYS = 40;
const char TEST_CONTROL = 41;
