//
// Copyright 1995,1996 Steve Passe
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHOR (Steve Passe)
// is not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHOR makes no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHOR
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// AUTHOR:     Steve Passe <smp@csn.net>
//

// rcsid[] = "$Id: xmltherm.hh,v 1.1 1996/03/16 02:21:59 smp Exp smp $";

#ifndef _XMLTHERM
#define _XMLTHERM


#define XADC
#define MAX_CHANNELS		8

#define MIN_VALUE		40
#define MIN_VALUE_STR		"40"

#define MAX_VALUE		255
#define MAX_VALUE_STR		"255"

#define MAX_RATE		999
#define MAX_RATE_STR		"999"


#define HI_BACKGROUND		"lightGrey"
#define LO_BACKGROUND		"slateGrey"
#define DEFAULT_BACKGROUND	LO_BACKGROUND

#define NIL_LABEL		"---"
#define NIL_COLOR		HI_BACKGROUND

#define RATE_COLOR		"lightBlue"
#define ALARM1_COLOR		"lightYellow"
#define ALARM2_COLOR		"pink"

#define OK_FCOLOR		"green"
#define ALARM1_FCOLOR		"yellow"
#define ALARM2_FCOLOR		"red"


//
// Application resources
//
#define	XtNchannelCount	"channelCount"
#define	XtCChannelCount	"ChannelCount"
#define	XtNchannelList	"channelList"
#define	XtCChannelList	"ChannelList"


//
// the adjustor object
//
typedef struct {
    Widget	form;
    Widget	label;
    Widget	wheel;
    int		min;
    int		max;
    int		val;
    int		type;
} adjustor_t;


//
// the display object
//
typedef struct {
    Widget	form;
    Widget	label;
    Widget	lcd;
    adjustor_t	alarm1;
    adjustor_t	alarm2;
    adjustor_t	rate;
#if 1
    int		device;
#endif
} display_t;


#include "../daemon/rcclient.hh"


#define MAX_INPUT		1024
#define COMMENT_CHAR		'#'

#define STATUS_MSG_START	'<'


class MLControl : public RcClient
{

 public:

    // constructor
    MLControl( const char* name ) : RcClient( name ) {}

    // destructor
    virtual		~MLControl( void ) {}

    // initialize Control
    virtual int		initialize( const char* path,
				    const char* logFile )
    			{ return RcClient::initialize( path, logFile ); }

    // the main loop
    int			mlMain( void );
};

#endif  // _XMLTHERM
