//
// Copyright 1996 Steve Passe
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHOR (Steve Passe)
// is not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHOR makes no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHOR
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// AUTHOR:     Steve Passe <smp@csn.net>
//

// rcsid[] = "$Id: procfork.h,v 1.1 1996/02/05 06:29:58 smp Exp smp $";


#ifndef _PROCFORK_H
#define _PROCFORK_H


class ProcFork
{
    public :

	ProcFork( void );
	~ProcFork( void ) {};

	int pRead( u_char* buffer, int count )
				{ return read( _input, buffer, count ); }
	int pWrite( u_char* buffer, int count )
				{ return write( _output, buffer, count ); }

	int getInputFD() { return _input; }
	int getOutputFD() { return _output; }

	int getParentPID() { return _parentPID; }
	int getChildPID() { return _childPID; }

	int amParent() { return _amParent; }
	int amChild() { return _amChild; }

    private :

	int _input;
	int _output;
	int _amParent;
	int _amChild;
	int _parentPID;
	int _childPID;
	int _create_error;
};


#endif  // _PROCFORK_H
