//
// Copyright 1993,1994,1995 Steve Passe and Paul Crook
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1995 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//              Paul Crook
//

static char rcsid[] = "$Id: tokens.cc,v 1.2 1996/03/02 07:50:09 smp Exp smp $";


//
// tokens.cc, break up a string into at most 'num' tokens
//

#include <string.h>

#include "misc.hh"
#include "tokens.hh"


Tokens::Tokens( char* s, int num )
{
    int		cnt;
    char*	p;
    char*	val;
    char**	ap;

    // get storage for av[]
    av = new char*[ num + 1 ];

    // leave room for 'remainder'
    ac = num - 1;

    // break out 1st ac fields
    for ( ap = av, cnt = 0, p = s; p != NULL;  )
    {
	// look for valid token
	while ((val = strsep(&p, " \t\n")) != NULL && *val == '\0') /* WS */;

	// found one
	if ( val )
	{
	    *ap++ = val;
	    if ( ++cnt == ac ) break;
	}
    }

    // put 'remainder' of string into last arg
    if ( p )
    {
	while ( isspace( *p ) ) ++p; // remove WS
	if ( *p )
	{
	    for ( val = p + strlen( p ) - 1; isspace( *val ); --val );
	    *(val+1) = '\0';
	    *ap++ = p;
	    ++cnt;
	}
    }

    // terminate av[] list
    *ap = 0;
    ac = cnt;
}
