//
// Copyright 1993,1994,1995 Steve Passe and Paul Crook
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of AUTHORS (Steve Passe and Paul Crook)
// are not be used in advertising or publicity pertaining to distribution of
// the software without specific, written prior permission.  AUTHORS make no
// representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
// AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL AUTHORS
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// 1995 Revision
// AUTHORS:     Steve Passe <smp@csn.net>
//              Paul Crook
//

// $Id: udgsocket.hh,v 1.3 1996/03/31 02:22:50 smp Exp smp $

//
// header for udgsocket.cc
//

#ifndef _UDGSOCKET_H
#define _UDGSOCKET_H


#include <sys/socket.h>
#include <sys/un.h>

#define UDG_TMPADDR		"/tmp/dg.XXXXXX"
#define UDG_TMPADDR_SIZE	15

typedef struct unixSockAddr UNIXSOCKADDR;

struct unixSockAddr {
    struct sockaddr_un	addr;
    int			len;
};

class UnixDGSocket {

 public:

    UnixDGSocket( char* myName, char* destName = NULL );
    ~UnixDGSocket();

    int send( const char* buf, int len, UNIXSOCKADDR* dest = NULL );
    int recv( char* buf, UNIXSOCKADDR* returnAddr = NULL );

    int getFD() { return _socketFD; }

    static int makeAddress( UNIXSOCKADDR& addr, const char* path );


 private:

    int			_socketFD;
    UNIXSOCKADDR	_myAddr;
    UNIXSOCKADDR	_destAddr;

};


#endif  // _UDGSOCKET_H
